<%-- SiteMinder 12.52 chs/jsps/tenantlogin.jsp modified to send json or html based on the value of the X-Requested-With HTTP Header --%>
<%@page pageEncoding="UTF-8" import="java.util.List,java.net.URL,com.ca.federation.cloud.BrandInfo,com.ca.federation.cloud.ApplicationObject,com.ca.federation.cloud.AuthenticationObject,com.ca.federation.cloud.TenantObject,com.ca.federation.cloud.util.CHSConstants,com.ca.federation.cloud.util.ResourceBundleHelper" errorPage="errorpage.jsp"%>
<%-- Add json-simple version 1.1.1 or higher to the chs/WEB-INF/lib directory --%>
<%@page import="org.json.simple.JSONObject,org.json.simple.JSONArray,org.json.simple.JSONValue"%>
<% String contextPath = request.getContextPath(); %>
<% BrandInfo brandInfo = (BrandInfo) application.getAttribute("brandInfo"); %>
<%
ResourceBundleHelper bundle = new ResourceBundleHelper(request.getLocale());
%>
<% 
response.addHeader("Cache-Control", "no-cache, no-store, must-revalidate"); // HTTP 1.1
response.addHeader("Pragma", "no-cache"); // HTTP 1.0
response.addHeader("Expires", "Thu, 01 Jan 1970 00:00:00 GMT");
%>
<%-- move java before content --%>
<%
TenantObject tenant = (TenantObject) request.getAttribute("tenant");
ApplicationObject applicationObj = (ApplicationObject) request.getAttribute("application");
List<AuthenticationObject> listAuthSchemes = applicationObj.getAuthSchemeObjects();
boolean noPublicAuthSchemesFlag = false;
String selfRegURL = null;
if(application != null){
	selfRegURL = applicationObj.getSelfRegURL();
}
boolean	isSelfRegEnabled = (selfRegURL != null && !"".equals(selfRegURL) ) || (applicationObj.isRegistrationEnabled());
%>
<%-- choose content type based on HTTP Header --%>
<% if (null != request.getHeader("X-Requested-With") && request.getHeader("X-Requested-With").equals("XMLHttpRequest")) { %>
<% // JSON response
response.setContentType("application/json; charset=utf-8");

JSONObject json = new JSONObject();

// tenant data
if (null != tenant) {
	JSONObject jsonTenant = new JSONObject();
	jsonTenant.put("description", tenant.getTenantInfo());
	jsonTenant.put("name", tenant.getTenantTitle());

	// tenant logo
	JSONObject jsonTenantLogo = new JSONObject();
	//jsonTenantLogo.put("url", tenant.getLogoURL()); // Note: there is no tenant configuration in SiteMinder CHS
	//jsonTenantLogo.put("url", contextPath + "/images/ca_log.png");
	jsonTenantLogo.put("url", "/static/img/ca-logos-svg/CA_r_1cR.svg");
	jsonTenant.put("logo", jsonTenantLogo);

	// footer links
	JSONArray jsonFooterLinks = new JSONArray();
	JSONObject jsonFooterLink1 = new JSONObject();
	jsonFooterLink1.put("url", tenant.getFooter1Link());
	jsonFooterLink1.put("name", tenant.getFooter1Text());
	jsonFooterLinks.add(jsonFooterLink1);
	JSONObject jsonFooterLink2 = new JSONObject();
	jsonFooterLink2.put("url", tenant.getFooter2Link());
	jsonFooterLink2.put("name", tenant.getFooter2Text());
	jsonFooterLinks.add(jsonFooterLink2);
	JSONObject jsonFooterLink3 = new JSONObject();
	jsonFooterLink3.put("url", tenant.getFooter3Link());
	jsonFooterLink3.put("name", tenant.getFooter3Text());
	jsonFooterLinks.add(jsonFooterLink3);

	jsonTenant.put("footerlinks", jsonFooterLinks);

	json.put("tenant", jsonTenant);
}

// application
JSONObject jsonApplication = new JSONObject();
JSONObject jsonSelfRegistration = new JSONObject();
jsonSelfRegistration.put("enabled", isSelfRegEnabled);
jsonApplication.put("selfregistration", jsonSelfRegistration);
json.put("application", jsonApplication);

// labels
JSONObject jsonLabel = new JSONObject();
JSONObject jsonCHSUI = new JSONObject();
JSONObject jsonScreen = new JSONObject();
jsonScreen.put("logintitle", bundle.getLabelValue("label.chsui.loginscreen.logintitle",brandInfo.getBrandTitle()));
jsonScreen.put("login", bundle.getLabelValue("label.chsui.loginscreen.login"));
jsonScreen.put("noauthschemesfound", bundle.getLabelValue("label.chsui.loginscreen.noauthschemesfound"));
jsonCHSUI.put("loginscreen", jsonScreen);
jsonLabel.put("chsui", jsonCHSUI);
json.put("label", jsonLabel);

// authentication methods
JSONArray jsonMethods = new JSONArray();
JSONObject jsonMethod = null;
JSONObject jsonMethodLogo = null;
for (AuthenticationObject authentication : listAuthSchemes) {
	jsonMethod = new JSONObject();
	jsonMethod.put("url", authentication.getUrlToDisplay());
	jsonMethod.put("description", authentication.getDescription());
	jsonMethod.put("name", authentication.getName());
	
	jsonMethodLogo = new JSONObject();
	jsonMethodLogo.put("url", authentication.getLogoURL());
	jsonMethod.put("logo", jsonMethodLogo);
	
	jsonMethods.add(jsonMethod);
}

json.put("methods", jsonMethods);

// form/basic authentication
// NOTE: SiteMinder CHS only allows federation partnerships, not "local login"
// One thought is to send the required form fields in JSON
// the html page would contain logic to reveal a form when the logo is clicked
// and submit the form to an fcc
jsonMethod = new JSONObject();
jsonMethod.put("description", bundle.getLabelValue("label.chsui.loginscreen.useyourtenantaccount", tenant.getTenantTitle()));

// NOTE: option 1: treat this like any other login by presenting a link and logo
// This is not desired due to additional browser redirection
jsonMethod.put("url", applicationObj.getDefaultAuthSchemeURL());
jsonMethodLogo = new JSONObject();
//jsonMethodLogo.put("url", contextPath + "/images/ca_log.png");
jsonMethodLogo.put("url", "/static/img/ca-logos-svg/catechnologies.svg");
jsonMethod.put("logo", jsonMethodLogo);

// NOTE: option 2: embed the form in the login dialog
JSONObject jsonForm = new JSONObject();
jsonForm.put("action", "/login.fcc");

JSONArray jsonFormFields = new JSONArray();
JSONObject jsonUsername = new JSONObject();
jsonUsername.put("field", "USER");
jsonUsername.put("name", "Username");
jsonUsername.put("type", "text");
jsonFormFields.add(jsonUsername);

JSONObject jsonPassword = new JSONObject();
jsonPassword.put("field", "PASSWORD");
jsonPassword.put("name", "Password");
jsonPassword.put("type", "password");
jsonFormFields.add(jsonPassword);

jsonForm.put("fields", jsonFormFields);
jsonMethod.put("form", jsonForm);
json.put("local", jsonMethod);


out.print(json.toJSONString());
	out.flush();
%>
<% } else { // if X-Requested-With %>
<%-- original SiteMinder 12.52 login page --%>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<script language='JavaScript'>
<!-- Cross-frame scripting prevention: This code will prevent this page from being encapsulated within HTML frames. Remove, or comment out, this code if the functionality that is contained in this SiteMinder page is to be included within HTML frames. -->

if (top !=self) 
top.location=self.location; 

function setIFrameHeight(){
	try {
		tdHeight  = document.documentElement.offsetHeight * 70 / 100; //70% total td height in overall page height
		frameHeight = Math.round(tdHeight * 50 / 100); // 50% iframe height % in the td height
		document.getElementById('iframe1').style.height = frameHeight;
	} catch(err)
  { }
}

</SCRIPT>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title><%=bundle.getLabelValue("label.chsui.loginscreen.logintitle",brandInfo.getBrandTitle())%></title>
<link rel="stylesheet" type="text/css" href="<%=contextPath%>/css/cam.css" />
</head>
<body onload="setIFrameHeight();" onresize="setIFrameHeight();">
<%
	    URL customHeaderFileURL = null;
	    String headerFile = "header.jsp";
	    String customHeaderFile = "header-custom.jsp";
	    customHeaderFileURL = pageContext.getServletContext().getResource("jsps/"+customHeaderFile);	    
%>	    
	    <% if(customHeaderFileURL == null) { %>
		<jsp:include page="<%=headerFile%>" flush="true"/>
	   <% } else { %>
		<jsp:include page="<%=customHeaderFile%>" flush="true"/>
	   <% } %>

<table  width="80%" border="0" cellpadding="0"
			class="ca-footer-section" valign="top"  align="center" height="80%">
			<tr height="10%">
			<td colspan="4"> 
			<span class="ca-label-headtext"><%=bundle.getLabelValue("label.chsui.loginscreen.login")%></span>          
			</td>
			</tr>
			<tr height="10%">
			<td class="ca-footer-section" colspan="4" valign="top">
				<hr />
			</td>
			</tr>

			<tr height="60%" valign="top">
				<td  valign="top" align="center" width="25%">
				<%
				if (listAuthSchemes != null && !listAuthSchemes.isEmpty()) { 
					if(applicationObj.containsSocialAuthSchemes()){
				%>
				<div align="left" class="ca-msg-text"><%=bundle.getLabelValue("label.chsui.loginscreen.chooseaccounttosignin")%></div>
				 <% }
				}%>
				<table width="100%" cellspacing="0" cellpadding="15">
				<%
				if (listAuthSchemes != null && !listAuthSchemes.isEmpty()) { 
					boolean separationFlag = false;
					int incr = 0;
					for (int i = 0; i < listAuthSchemes.size(); i++, incr++) {
					AuthenticationObject authSchemeObj = listAuthSchemes.get(i);
					if((applicationObj.getDefaultAuthId() != null) && (applicationObj.getDefaultAuthId().equalsIgnoreCase(authSchemeObj.getId()))) {
						continue;
					}
					if(!separationFlag && applicationObj.containsSocialAuthSchemes() && !authSchemeObj.isSocial()){
						separationFlag = true;	
						incr = 0;
				%>
						</tr>
						<tr valign="top">
						<td colspan="3">
						<hr/>
						</td>
						</tr>
				
						<%} //separation flag
				if (incr%3 == 0 ) { %>
				<tr>
				<% } %>			
				
				<td width="33%" valign="top" align="center">
					<table cellspacing="0" cellpadding="0" >
					<tr>
						<td align="center" style="height: 60px">
							<a	href="<%=authSchemeObj.getUrlToDisplay()%>" title="<%=authSchemeObj.getDescription()%>"><img border="0"
															alt="<%=authSchemeObj.getDescription()%>"
															src="<%=authSchemeObj.getLogoURL()%>"
															width="40" height="40"> 
							</a>
						</td>
					</tr>
					<tr>
						<td class="ca-icon-text" align="center"><%=authSchemeObj.getName()%></td>
					</tr>
					</table>
				</td>
				<% if ((incr+1)%3 == 0) { %>
				</tr>
				<% }%>
				
				<% 
					} //end loop
				} //end if
				 else {
				 //show no auth schemes
				 noPublicAuthSchemesFlag = true;
				 if (applicationObj.getDefaultAuthScheme() == null) {
				 %>
				<tr>
					<td class="ca-msg-text" align="center"><%=bundle.getLabelValue("label.chsui.loginscreen.noauthschemesfound")%></td>
				</tr>
				 <%
				 }
				 }
				%>
				</table>
				</td>
				<%
				if(applicationObj.getDefaultAuthScheme() != null){
				if(!noPublicAuthSchemesFlag) {
				%>
				<td>
				<table width="100%" height="100%">
				<tr>
				<td	class="border"></td>
				</tr>
				</table>
				</td>
				<%} //end of separator%>
				
				<td width="65%" align="left">
				<table height="5%">
				<tr>
					<td align="left" class="ca-msg-text"><%=bundle.getLabelValue("label.chsui.loginscreen.useyourtenantaccount", tenant.getTenantTitle())%></td>
				</tr>
				<tr>
					<td align="left">
						<%-- 
						Below attributes are to read error message first on login failure by accessibility tools (ex:JAWS)
						aria-live="assertive" for Chrome
						role="alert" for IE/firefox
						--%>
						<span id="errormessage" aria-live="assertive" role="alert" class="ca-error-text"></span>
					</td>
				</tr>
				<tr>
				<td>&nbsp;</td>
				</tr>
				</table>
				<table width="100%" valign="top" height="55%" >
					<tr width="100%">
						<td width="100%">
							<iframe src="<%=applicationObj.getDefaultAuthSchemeURL()%>&iframe=yes&random=<%=Math.random()%>" frameborder="0" seamless="seamless" height="100%" width="100%" id="iframe1" marginheight="0">
						</iframe>
						</td>
					 </tr>
				</table>
				
				<table width="100%" height="15%" valign="top">
					<tr>
						<td width="100%" align="left" valign="top"><a href="<%=tenant.getForgotUserNameLink()%>" class="ca-link-text"><%=bundle.getLabelValue("label.chsui.loginscreen.forgotusername")%></a><span class="ca-msg-text">&nbsp;&nbsp;</span><a href="<%=tenant.getForgotPWDLink()%>" class="ca-link-text"><%=bundle.getLabelValue("label.chsui.loginscreen.forgotpassword")%></a></td>
					 </tr>
				</table>
				</td>
				<%
				}
				%>
			</tr>
			<tr height="10%" valign="top">
				<td><% if(isSelfRegEnabled) { %>
						<a class="ca-link-text" href="<%=request.getAttribute(CHSConstants.ORIGINAL_REQ_URL) + CHSConstants.REGISTER_QUERY_PARAM%>"><%=bundle.getLabelValue("label.chsui.loginscreen.firsttimhere")%></a>
					<% } %>
				</td>
			</tr>
    </table>
<%
	    URL customFooterFileURL = null;
	    String footerFile = "footer.jsp"; 
	    String customFooterFile = "footer-custom.jsp";
	    customFooterFileURL = pageContext.getServletContext().getResource("jsps/"+customFooterFile);
%>	    
	   <% if(customFooterFileURL == null) { %>
	   	<jsp:include page="<%=footerFile%>" flush="true"/>
	   <% } else { %>
	   	<jsp:include page="<%=customFooterFile%>" flush="true"/>
	   <% } %>		
</body>
</html>
<% } // if X-Requested-With %>